#ifndef __LCD__
#define __LCD__

#include <p18f452.h>
#include <delays.h>


//dfinition des contantes et des prototypes des fonctions

//--- LCD ---//

#define LCD_CSA	PORTBbits.RB1			//contrleur A

#define LCD_CSB PORTBbits.RB2			//contrleur B

#define LCD_RS PORTBbits.RB3			//registre

#define LCD_RW PORTBbits.RB4			//lecture / criture

#define LCD_Enable PORTBbits.RB5		//activation

#define LCD_Reset PORTBbits.RB0			//reset

#define LCD_BackLight PORTBbits.RB6		//rtro-clairage

#define LCD_DATA PORTD					//port de donnes


//--- PROTOTYPES ---//

void LCD_Init(void);
void LCD_Write_Command(unsigned char Data);
void LCD_Send_Data(unsigned char Data);
unsigned char LCD_Read_Data(void);
void LCD_GotoXY(unsigned char X, unsigned char Y);
void LCD_Clear(void);
void LCD_PutChar(char ch);
void LCD_PutStringRom(const rom char *tab, unsigned char X, unsigned char Y);
void LCD_PutString(const char *tab, unsigned char X, unsigned char Y);
void LCD_PutPixel(unsigned char X, unsigned char Y);

#endif