#pragma config WDT = OFF										// Pas de watchdog
#pragma config OSC = HS											// HS pour un quartz de 20MHz
#include <p18f452.h>
#include "GameGirl.h"
#include "lcd.h"
#include "rpg.h"
#include <delays.h>
#include <stdio.h>

// Fonction d'initialisation de la GameGirl
void InitGameGirl(void)
{
	ConfigProcessor();											//configuration des registres du processeur
	LCD_Init();													//initialisation de l'cran lcd
	LCD_BackLight=1;											//allumer rtro-clairage
	LCD_Clear();												//effacer LCD
}


/*-----// INFORMATIONS //-----//

Ce jeu est inspir de la clbre srie Castlevania cre par KONAMI.
Vous traverserez plusieurs tages du chteau de Dracula en tant que Simon Belmont,
vous affronterez diffrents types de monstres.

Ceci est une version dmo. Quelques indications pour mieux comprendre le programme :

- pv est la variable utilise pour les points de vie du hros dans les fonctions
- pm est la variable utilise pour les points de magie du hros dans les fonctions
- pvm est la variable utilise pour les points de vie des monstres dans les fonctions
- atkm est la variable utilise pour la valeur d'attaque des monstres dans les fonctions
(voir rpg.h et rpg.c)

Les commandes indiques en combat sont :
- R pour le bouton rouge
- B pour le bouton bleu
- G pour le bouton vert
- Y pour le bouton jaune

Il faut gnralement appuyer sur le bouton rouge pour passer les messages et autres dialogues.

*/





//-----// MAIN //-----//

void main(void)
{
	unsigned char pvheros=120;									//pv de dpart du hros
	unsigned char pmheros=100;									//pm de dpart du hros
	unsigned char pvmonstre=50;									//pv des monstres  0
	unsigned char atkmonstre=10;								//atk des monstres  0

	InitGameGirl();												//initialisation de la GameGirl

	do{															//on excute la dmo  l'infini

	//affichage de l'cran titre
	AfficheLevel("Title");

	//message d'introduction
	LCD_Clear();
	LCD_PutStringRom("En Transylvanie existe un lieumaudit queles hommes ont coutume d'appeler...",0,0);
	LCD_PutStringRom("    CASTLEVANIA     ",0,5);
	while(Button_Red);
	
	//message
	Message("   En tantque Simon Belmont,  puissant  chasseur  de vampire, vous devez mettre fin au regne du comte Vlad Tepes Dracula");

	//affichage de l'entre du chteau
	AfficheLevel("Entrence");
	
	//message
	Message("Vous franchissez la herse du  chateau,  des bruitsse font entendre dans les couloirs...");
	
	//premiers combats
	Battle("BAT",&pvheros,&pmheros,&pvmonstre,&atkmonstre);
	Battle("ZOMBIE",&pvheros,&pmheros,&pvmonstre,&atkmonstre);

	//message
	Message("Il semble y en avoird'autres!");

	//plusieurs autres combats
	Battle("BAT",&pvheros,&pmheros,&pvmonstre,&atkmonstre);	
	Battle("ZOMBIE",&pvheros,&pmheros,&pvmonstre,&atkmonstre);
	Battle("ZOMBIE",&pvheros,&pmheros,&pvmonstre,&atkmonstre);

	//message
	Message("Vous trouvez une saferoom, vospv et pm sont restaures!");

	//on restaure les valeurs de base des pv et pm du hros
	pvheros=120;
	pmheros=100;
	
	//affichage de la saferoom
	AfficheLevel("SafeRoom");
	
	//message
	Message("Vous quittez la saferoom et vous dirigezvers de bien sombrescouloirs.");
	
	//affichage de la gallerie de marbre
	AfficheLevel("MarbleGallery");

	//messages
	Message("Les couloirs de la  galerie demarbre vous semblentpeu accueillants");
	Message("Un bruit  de cliquetis se faitentendre...");

	//plusieurs combats contre des squelettes
	Battle("SKULL",&pvheros,&pmheros,&pvmonstre,&atkmonstre);
	Battle("SKULL",&pvheros,&pmheros,&pvmonstre,&atkmonstre);
	Battle("SKULL",&pvheros,&pmheros,&pvmonstre,&atkmonstre);

	//affichage de la clocktower
	AfficheLevel("ClockTower");

	//apparition de La Mort
	Message("LA MORT:                                Je vois que tu es arrive jusqu'a moi Belmont, maisne crois  pas que jete laisserai vaincrele maitre!");

	//combat contre La Mort
	Battle("DEATH",&pvheros,&pmheros,&pvmonstre,&atkmonstre);
	
	//fin de la dmo - remerciements
	LCD_Clear();
	LCD_PutStringRom("FIN DE LA DEMO 1.0, MERCI D'AVOIR JOUE!",0,1);
	LCD_PutStringRom("BY ARUKADO",0,5);
	while(Button_Red);

	Message("Vous pouvez rejouer cette demoavec vos  stats actuels !");
	
	}while(1);
}