#include "rpg.h"
#include <delays.h>
#include <stdio.h>



//-----// COMBATS //-----//


//-- Affichage de l'aire de combat --//

void BattleHUD(const rom char *Monster, char *pv, char *pm, char *pvm)
{
	unsigned char i;													//dclaration d'un compteur

	char BufferPV[25];													//dclaration d'un buffer pour les pv du hros
	char BufferPM[25];													//dclaration d'un buffer pour les pm du hros
	char BufferPVM[25];													//dclaration d'un buffer pour les pv des monstres

	sprintf(BufferPV,"%d  ",(int)*pv);									//on met la valeur des pv du hros dans le buffer
	sprintf(BufferPM,"%d  ",(int)*pm);									//on met la valeur des pm du hros dans le buffer
	sprintf(BufferPVM,"%d  ",(int)*pvm);								//on met la valeur des pv des monstres dans le buffer


	LCD_PutStringRom("SIMON",3,0);										//afficher nom du hros

	LCD_PutStringRom(Monster,13,0);										//afficher nom du monstre

	LCD_PutStringRom("PV:",0,1);										//afficher un indicateur PV

	LCD_PutString(BufferPV,3,1);										//afficher la valeur des pv du hros

	LCD_PutStringRom("PM:",0,2);										//afficher un indicateur PM

	LCD_PutString(BufferPM,3,2);										//afficher la valeur des pm du hros

	LCD_PutStringRom("PV:",12,1);										//afficher un indicateur PV

	LCD_PutString(BufferPVM,15,1);										//afficher la valeur des pv du monstre

	LCD_PutStringRom("----------",0,3);									//afficher la ligne de sparation avec le menu des choix

	for(i=0;i<8;i++)													//pour i allant de 0  7
		LCD_PutStringRom("|",10,i);										//afficher la ligne de sparation entre le hros et le monstre
}


//-- Gestion des menus du combat --//

void Battle(const rom char *Monster, char *pv, char *pm, char *pvm, char *atkm)
{	

	char pv_old=0;														//dclaration d'une mmoire pour les pv du hros
	char pm_old=0;														//dclaration d'une mmoire pour les pm du hros
	char pvm_old=0;														//dclaration d'une mmoire pour les pv du monstre

	AfficheMonster(Monster,pvm,atkm);									//afficher le monstre

	do																	//faire jusqu' ce que le monstre n'ait plus de pv
	{	
		pv_old=*pv;														//garder les pv actuels du hros en mmoire
		pm_old=*pm;														//garder les pm actuels du hros en mmoire
		pvm_old=*pvm;													//garder les pv actuels du monstre en mmoire

		BattleHUD(Monster, pv, pm, pvm);								//afficher de l'aire de combat

		LCD_PutStringRom("R-ATTAQUE",1,4);								//afficher la ligne du menu attaque
		LCD_PutStringRom("B-MAGIE  ",1,5);								//afficher la ligne du menu magie
		LCD_PutStringRom("G-OBJET  ",1,6);								//afficher la ligne du menu objets
		LCD_PutStringRom("Y-FUIR   ",1,7);								//afficher la ligne de la fuite

		if(!Button_Red)													//si bouton rouge
		{
			Delay10KTCYx(100);											//attendre

			BattleATK(pv, pm, pvm, atkm);								//aller dans le menu attaque

			Delay10KTCYx(100);											//attendre
		}
		
		if(!Button_Blue)												//si bouton bleu
		{
			Delay10KTCYx(100);											//attendre

			BattleMAG(pv, pm, pvm, atkm);								//aller dans le menu magie

			Delay10KTCYx(100);											//attendre
		}
		
		if(!Button_Green)												//si bouton vert
		{
			Delay10KTCYx(100);											//attendre

			BattleOBJ(pv, pm, pvm, atkm);								//aller dans le menu objets

			Delay10KTCYx(100);											//attendre
		}
		
		if(!Button_Yellow)												//si bouton jaune
		{
			Delay10KTCYx(100);											//attendre
			
			BattleFLEE();												//fuite
			
			Delay10KTCYx(100);											//attendre
		}

		BattleHUD(Monster, pv, pm, pvm);								//actualisation de l'aire de combat

		if(*pvm<=0) *pvm=0;												//les pv du monstres ne descendent pas plus bas que 0
		if(*pm<=0) *pm=0;												//les pm du hros ne descendent pas plus bas que 0

		
		//si le hros s'est rgnr (pv ou pm), ou s'il a bless le monstre, le monstre engage une attaque ( condition qu'il soit encore vivant)
		if(((pv_old<*pv)||(pm_old<*pm)||(pvm_old>*pvm))&&(*pvm>0)) MonsterATK(pv, atkm);

		
		if(*pv<=0)														//si le hros meurt
		{
			*pv=0;														//les pv du hros ne descendent pas plus bas que 0
			Death();													//afficher l'cran de game over
		}

	}while(*pvm>0);
	
	
	//afficher l'cran de fin de combat
	LCD_Clear();
	LCD_PutStringRom("                    ",0,0);
	LCD_PutStringRom("--- BATTLE END  --- ",0,1);
	LCD_PutStringRom("                    ",0,2);
	LCD_PutStringRom(Monster,2,3);
	LCD_PutStringRom("             VAINCU!",0,4);
	LCD_PutStringRom("                    ",0,5);
	LCD_PutStringRom("--- BATTLE END  --- ",0,6);
	LCD_PutStringRom("                    ",0,7);

	while(Button_Red);													//tant que bouton rouge non appuy

	Delay10KTCYx(100);													//attendre
}


//-- Menu Attaque --//

void BattleATK(char *pv, char *pm, char *pvm, char *atkm)
{
	unsigned char atk=1;												//dclaration de la variable d'autorisation d'attaque

	do{																	//faire tant que bouton jaune non appuy ou interdiction d'attaque

				LCD_PutStringRom("R-FOUET  ",1,4);						//afficher la ligne du fouet
				LCD_PutStringRom("B-CROIX  ",1,5);						//afficher la ligne de la croix
				LCD_PutStringRom("G-DAGUE  ",1,6);						//afficher la ligne de la dague
				LCD_PutStringRom("Y-RETOUR ",1,7);						//afficher la ligne retour
			
				if(!Button_Red)											//si bouton rouge
				{	
					Delay10KTCYx(100);									//attendre

					LCD_PutStringRom("-20PV!   ",1,4);					//afficher les pv que le monstre perd
					LCD_PutStringRom("         ",1,5);
					LCD_PutStringRom("         ",1,6);
					LCD_PutStringRom("         ",1,7);

					*pvm=*pvm-20;										//faire perdre 20pv au monstre
					
					atk=0;												//interdire attaque (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}

				if(!Button_Blue)										//si bouton bleu
				{	
					Delay10KTCYx(100);									//attendre

					if(*pm>=20)											//si le hros a assez de pm
					{
						LCD_PutStringRom("-50PV!   ",1,4);				//afficher les pv que le monstre perd
						LCD_PutStringRom("         ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);

						*pvm=*pvm-50;									//faire perdre 50pv au monstre
						*pm=*pm-20;										//faire perdre 20pm au hros
					}
					else												//sinon
					{
						LCD_PutStringRom("PAS ASSEZ",1,4);				//afficher message d'avertissement
						LCD_PutStringRom("DE PM !  ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					}
					
					atk=0;												//interdire attaque (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}

				if(!Button_Green)										//si bouton vert
				{	
					Delay10KTCYx(100);									//attendre

					if(*pm>=10)											//si le hros a assez de pm
					{
						LCD_PutStringRom("-30PV!   ",1,4);				//afficher les pv que le monstre perd
						LCD_PutStringRom("         ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);

						*pvm=*pvm-30;									//faire perdre 30pv au monstre
						*pm=*pm-10;										//faire perdre 10pm au hros
					}
					else												//sinon
					{
						LCD_PutStringRom("PAS ASSEZ",1,4);				//afficher message d'avertissement
						LCD_PutStringRom("DE PM !  ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					}
					
					atk=0;												//interdire attaque (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}

	}while( Button_Yellow && (atk!=0));
}


//-- Menu Magie --//

void BattleMAG(char *pv, char *pm, char *pvm, char *atkm)
{
	unsigned char mag=1;												//dclaration de la variable d'autorisation de magie

	do{																	//faire tant que bouton jaune non appuy ou interdiction de magie
	
				LCD_PutStringRom("R-FLAMME ",1,4);						//afficher la ligne du sort flamme
				LCD_PutStringRom("B-FOUDRE ",1,5);						//afficher la ligne du sort foudre
				LCD_PutStringRom("G-GEL    ",1,6);						//afficher la ligne du sort gel
				LCD_PutStringRom("Y-RETOUR ",1,7);						//afficher la ligne retour
			
				if(!Button_Red)											//si bouton rouge
				{	
					Delay10KTCYx(100);									//attendre

					if(*pm>=15)											//si le hros a assez de pm
					{
						LCD_PutStringRom("-45PV!   ",1,4);				//afficher les pv que le monstre perd
						LCD_PutStringRom("         ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);

						*pvm=*pvm-45;									//faire perdre 45pv au monstre
						*pm=*pm-15;										//faire perdre 15pm au hros
					}
					else												//sinon
					{
						LCD_PutStringRom("PAS ASSEZ",1,4);				//afficher message d'avertissement
						LCD_PutStringRom("DE PM !  ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					}
					
					mag=0;												//interdire magie (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}

				if(!Button_Blue)										//si bouton bleu
				{	
					Delay10KTCYx(100);									//attendre

					if(*pm>=15)											//si le hros a assez de pm
					{
						LCD_PutStringRom("-40PV!   ",1,4);				//afficher les pv que le monstre perd
						LCD_PutStringRom("         ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);

						*pvm=*pvm-40;									//faire perdre 40pv au monstre
						*pm=*pm-15;										//faire perdre 15pm au hros
					}
					else												//sinon
					{
						LCD_PutStringRom("PAS ASSEZ",1,4);				//afficher message d'avertissement
						LCD_PutStringRom("DE PM !  ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					}
					
					mag=0;												//interdire magie (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}

				if(!Button_Green)										//si bouton vert
				{	
					Delay10KTCYx(100);									//attendre
					
					if(*pm>=10)											//si le hros a assez de pm
					{
						LCD_PutStringRom("-30PV!   ",1,4);				//afficher les pv que le monstre perd
						LCD_PutStringRom("         ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);

						*pvm=*pvm-30;									//faire perdre 30pv au monstre
						*pm=*pm-10;										//faire perdre 10pm au hros
					}
					else												//sinon
					{
						LCD_PutStringRom("PAS ASSEZ",1,4);				//afficher message d'avertissement
						LCD_PutStringRom("DE PM !  ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					}
					
					mag=0;												//interdire magie (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}
			
	}while(Button_Yellow && (mag!=0));
}


//-- Menu Objets --//

void BattleOBJ(char *pv, char *pm, char *pvm, char *atkm)
{
	unsigned char obj=1;												//dclaration de la variable d'autorisation d'objets

	do{																	//faire tant que bouton jaune non appuy ou interdiction d'objets
	
				LCD_PutStringRom("R-POTION ",1,4);						//afficher la ligne de la potion
				LCD_PutStringRom("B-ELEXIR ",1,5);						//afficher la ligne de l'elexir
				LCD_PutStringRom("G-CYANURE",1,6);						//afficher la ligne du cyanure
				LCD_PutStringRom("Y-RETOUR ",1,7);						//afficher la ligne retour
			
				if(!Button_Red)											//si bouton rouge
				{	
					Delay10KTCYx(100);									//attendre
					
					if(*pv!=120)										//si le hros n'a pas le max de pv
					{
						LCD_PutStringRom("+50PV!   ",1,4);				//afficher les pv que le hros gagne
						LCD_PutStringRom("         ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					
						if(*pv<=70) *pv=*pv+50;							//si le hros a 70 pv ou moins, soigner 50 pv
						else *pv=120;									//sinon soigner directement au maximum
					}
					else												//sinon afficher message d'avertissement
					{
						LCD_PutStringRom("PV DEJA  ",1,4);				//afficher message d'avertissement
						LCD_PutStringRom("AU MAX ! ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					}
					
					obj=0;												//interdire objets (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}

				if(!Button_Blue)										//si bouton bleu
				{	
					Delay10KTCYx(100);									//attendre
					
					if(*pm!=100)										//si le hros n'a pas le max de pm
					{
						LCD_PutStringRom("+40PM!   ",1,4);				//afficher les pm que le hros gagne
						LCD_PutStringRom("         ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					
						if(*pm<=60) *pm=*pm+40;							//si le hros a 60 pm ou moins, soigner 40 pm
						else *pm=100;									//sinon soigner directement au maximum
					}
					else												//sinon afficher message d'avertissement
					{
						LCD_PutStringRom("PM DEJA  ",1,4);				//afficher message d'avertissement
						LCD_PutStringRom("AU MAX ! ",1,5);
						LCD_PutStringRom("         ",1,6);
						LCD_PutStringRom("         ",1,7);
					}
					
					obj=0;												//interdire objets (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}

				if(!Button_Green)										//si bouton vert
				{	
					Delay10KTCYx(100);									//attendre

					LCD_PutStringRom("SUICIDE! ",1,4);					//afficher l'action
					LCD_PutStringRom("         ",1,5);
					LCD_PutStringRom("         ",1,6);
					LCD_PutStringRom("         ",1,7);

					*pv=0;												//mettre les pv du hros  0 (game over)
					
					obj=0;												//interdire objets (pour retourner directement au menu de choix atk/mag/obj/fuite)

					while(Button_Red);									//tant que bouton rouge non appuy
				}
			
	}while(Button_Yellow && (obj!=0));
}


//-- Fuite --//

void BattleFLEE(void)
{
	Delay10KTCYx(100);													//attendre

	LCD_PutStringRom("FUITE    ",1,4);									//afficher message d'avertissement
	LCD_PutStringRom("NON      ",1,5);
	LCD_PutStringRom("PERMISE! ",1,6);
	LCD_PutStringRom("         ",1,7);
					
	while(Button_Red);													//tant que bouton rouge non appuy
}


//-- Gestion des attaques du monstre --//

void MonsterATK(char *pv, char *atkm)
{
	Delay10KTCYx(100);													//attendre

	LCD_PutStringRom("L'ENNEMI ",1,4);									//afficher message d'avertissement
	LCD_PutStringRom("ATTAQUE! ",1,5);
	LCD_PutStringRom("         ",1,6);
	LCD_PutStringRom("         ",1,7);
			
	*pv=*pv-*atkm;														//blesser le hros avec l'atk du monstre
			
	while(Button_Red);													//tant que bouton rouge non appuy

	Delay10KTCYx(100);													//attendre
}


//-- Mort du hros et Game Over --//

void Death(void)
{
	LCD_Clear();														//effacer l'cran
		
	LCD_PutStringRom(" VOUS ETESMORT !!!  ",0,2);						//afficher game over
	LCD_PutStringRom("     -GAMEOVER-     ",0,4);
		
	while(1);															//jeu termin, redmarrage necessaire
}



//-----// AFFICHAGES //-----//


//-- Lieux --//

void AfficheLevel(const rom char *Level)
{

	//dclarations de variables pour identifier les lieux
	const rom char *saferoom="SafeRoom";
	const rom char *title="Title";
	const rom char *entrence="Entrence";
	const rom char *marblegallery="MarbleGallery";
	const rom char *clocktower="ClockTower";

	LCD_Clear();														//effacer l'cran
	
	//salle de rgnration

	if(*Level==*saferoom)												//si saferoom identifie
	{
		//affichage le lieu
		LCD_PutStringRom("   *  SAFEROOM  *   ",0,0);
		LCD_PutStringRom("       *    *       ",0,1);
		LCD_PutStringRom("  *              *  ",0,2);	
		LCD_PutStringRom("      *  <>  *      ",0,3);
		LCD_PutStringRom("  PRESS /()\\  RED  ",0,4);
		LCD_PutStringRom("    *    ||    *    ",0,5);
		LCD_PutStringRom("      * |__| *      ",0,6);
		LCD_PutStringRom("-------/____/-------",0,7);
	}
	
	//cran titre
	if(*Level==*title)													//si title identifi
	{
		//affichage le lieu
		LCD_PutStringRom(" ARUKADO'SCASTLE III",0,0);
		LCD_PutStringRom("        /\\         ",0,1);
		LCD_PutStringRom(" PRESS  ||/\\    TO ",0,2);
		LCD_PutStringRom("  RED   ||||   PLAY ",0,3);
		LCD_PutStringRom("     ...||||...     ",0,4);
		LCD_PutStringRom("     l        l     ",0,5);
		LCD_PutStringRom("      \\  /\\  /    ",0,6);
		LCD_PutStringRom("       l || l       ",0,7);
	}
	
	//entre du chteau
	if(*Level==*entrence)												//si entrence identifie
	{
		//affichage le lieu
		LCD_PutStringRom("    CASTLEENTRENCE  ",0,0);
		LCD_PutStringRom("     ____________   ",0,1);
		LCD_PutStringRom("     | | || | | |   ",0,2);
		LCD_PutStringRom("     | v vv v v |   ",0,3);
		LCD_PutStringRom("     |          |   ",0,4);
		LCD_PutStringRom("   PRESS      RED   ",0,5);
		LCD_PutStringRom("     |          |   ",0,6);
		LCD_PutStringRom("     |          |   ",0,7);
	}
	
	//gallerie de marbre
	if(*Level==*marblegallery)											//si marble gallery identifie
	{
		//affichage le lieu
		LCD_PutStringRom("    MARBLEGALLERY   ",0,0);
		LCD_PutStringRom("              <>    ",0,1);
		LCD_PutStringRom("   PRESS    --()--  ",0,2);
		LCD_PutStringRom("    RED       ||    ",0,3);
		LCD_PutStringRom("             |__|   ",0,4);
		LCD_PutStringRom("_/_/_/_/_//_/_/_/_/_",0,5);
		LCD_PutStringRom("/_/_/_/_/__/_/_/_/_/",0,6);
		LCD_PutStringRom("_/_/_/_/_//_/_/_/_/_",0,7);
	}

	//tour de l'horloge
	if(*Level==*clocktower)											//si clocktower identifie
	{
		//affichage le lieu
		LCD_PutStringRom("     CLOCKTOWER     ",0,0);
		LCD_PutStringRom("      ________      ",0,1);
		LCD_PutStringRom("     / ______ \\    ",0,2);
		LCD_PutStringRom("     |/ \\    \\|     ",0,3);
		LCD_PutStringRom("PRESS||  \\___|| RED ",0,4);
		LCD_PutStringRom("     ||      ||     ",0,5);
		LCD_PutStringRom("     |\\______/|     ",0,6);
		LCD_PutStringRom("      \\|    |/      ",0,7);
	}

	while(Button_Red);													//tant que bouton rouge non appuy

	Delay10KTCYx(100);													//attendre
}


//-- Monstres --//

void AfficheMonster(const rom char *Monster, char *pvm, char *atkm)
{

	//dclarations de variables pour identifier les monstres
	const rom char *bat="BAT";
	const rom char *zombie="ZOMBIE";
	const rom char *skull="SKULL";
	const rom char *death="DEATH";

	LCD_Clear();														//attendre

	//afficher l'cran de dbut de combat
	LCD_PutStringRom("                    ",0,0);
	LCD_PutStringRom("--- BATTLEPHASE --- ",0,1);
	LCD_PutStringRom("                    ",0,2);
	LCD_PutStringRom(Monster,2,3);
	LCD_PutStringRom("           APPARAIT!",0,4);
	LCD_PutStringRom("                    ",0,5);
	LCD_PutStringRom("--- BATTLEPHASE --- ",0,6);
	LCD_PutStringRom("                    ",0,7);

	while(Button_Red);													//tant que bouton rouge non appuy

	LCD_Clear();														//attendre

	//chauve-souris
	if(*Monster==*bat)													//si bat identifie
	{		
		//affichage du monstre
		LCD_PutStringRom("        ",12,2);
		LCD_PutStringRom("  (\\/)  ",12,3);
		LCD_PutStringRom("<^(oo)^>",12,4);
		LCD_PutStringRom("   mm   ",12,5);
		LCD_PutStringRom("        ",12,6);
		LCD_PutStringRom("        ",12,7);
		
		//rglages des pv et de l'atk du monstre
		*pvm=25;
		*atkm=5;
	}

	//squelette
	if(*Monster==*skull)												//si skull identifi
	{
		//affichage du monstre
		LCD_PutStringRom("   ___  ",12,2);
		LCD_PutStringRom("  (0.0) ",12,3);
		LCD_PutStringRom("   |||  ",12,4);
		LCD_PutStringRom(" m--l--m",12,5);
		LCD_PutStringRom("   -o-  ",12,6);
		LCD_PutStringRom("   l l  ",12,7);
		
		//rglages des pv et de l'atk du monstre
		*pvm=55;
		*atkm=20;
	}

	//zombie
	if(*Monster==*zombie)												//si zombie identifi
	{
		//affichage du monstre
		LCD_PutStringRom("   ___  ",12,2);
		LCD_PutStringRom("  (g g) ",12,3);
		LCD_PutStringRom("   |o|  ",12,4);
		LCD_PutStringRom(" m--|--m",12,5);
		LCD_PutStringRom("   | |  ",12,6);
		LCD_PutStringRom("   |||  ",12,7);
		
		//rglages des pv et de l'atk du monstre
		*pvm=45;
		*atkm=10;
	}
	
	//La Mort
	if(*Monster==*death)												//si death identifie
	{
		//affichage du monstre
		LCD_PutStringRom("   ___  ",12,2);
		LCD_PutStringRom("/T(0.0) ",12,3);
		LCD_PutStringRom(" | |||  ",12,4);
		LCD_PutStringRom(" |/   \\ ",12,5);
		LCD_PutStringRom(" ||   |m",12,6);
		LCD_PutStringRom(" /     \\ ",12,7);
		
		//rglages des pv et de l'atk du monstre
		*pvm=100;
		*atkm=50;
	}

	Delay10KTCYx(100);													//attendre
}


//-- Narration --//

void Message(const rom char *tab)
{
	LCD_Clear();														//effacer l'cran
	LCD_PutStringRom(tab,0,0);											//afficher le message voulu
	while(Button_Red);													//tant que bouton rouge non appuy
}